明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2112|回复: 9

[求助]如何将一系列的点(X i, Yi)拟合并连接成一条光滑的线?

[复制链接]
发表于 2007-4-30 10:15:00 | 显示全部楼层 |阅读模式
本帖最后由 作者 于 2007-5-5 9:25:58 编辑

有一系列的点(X i, Yi) (i=1 ,2 .........N),我用line连接每一点,成了N-1条线,用spline 连接,每次只能连接3个点,成了多线段,

请问:如何连接成一条光滑的曲线?(用vb在CAD中实现

谢谢!!!

发表于 2007-4-30 10:38:00 | 显示全部楼层
Public WithEvents PLine As AcadLWPolyline    ' Use with Modified Event Example
Sub Example_Modified()
     ' This example creates a lightweight polyline in model space and
     ' references the PolyLine using the public variable (PLine) which
     ' is set up to intercept Modified events.
     '
     ' This example then modifies the new object, triggering the code
     ' in the Modified event.
    
    Dim points(0 To 9) As Double
    
    ' Define the 2D polyline points
    points(0) = 1: points(1) = 1
    points(2) = 1: points(3) = 2
    points(4) = 2: points(5) = 2
    points(6) = 3: points(7) = 2
    points(8) = 4: points(9) = 4
        
    ' Create a lightweight Polyline object in model space
    '
    ' * Note: We are returning the new PolyLine object into a Module
    ' level variable.  This allows us to intercept events associated
    ' with that particular object.
    Set PLine = ThisDrawing.ModelSpace.AddLightWeightPolyline(points)
    
    ThisDrawing.Application.ZoomAll
    
    ' Modify object to trigger event.
    '
    ' * Note: The event code for the PolyLine modification will be triggered
    ' before we move forward and refresh the view, so the line will not
    ' appear blue when the event message box is displayed.
    Dim color As AcadAcCmColor
    Set color = AcadApplication.GetInterfaceObject("AutoCAD.AcCmColor.16")
    Call color.SetRGB(80, 100, 244)
    PLine.TrueColor = color

    ThisDrawing.Regen acAllViewports
    
End Sub


Private Sub PLine_Modified(ByVal pObject As AutoCAD.IAcadObject)
    ' This example intercepts an object's Modified event.
    '
    ' This event is triggered when an object supporting this event is modified.
    '
    ' To trigger this code: Modify an object connected to this event
    ' * Note: By connected, we mean the object set up to intercept events using
    ' the VBA WithEvents statement

    ' Use the "pObject" variable to determine which object was modified
    MsgBox "You just modified an object with an ID of: " & pObject.ObjectID
    
End Sub
 楼主| 发表于 2007-4-30 11:17:00 | 显示全部楼层

谢谢!

我试试看。

 楼主| 发表于 2007-4-30 16:17:00 | 显示全部楼层
连接的是多边形啊,我要的是曲线,不知道能否实现?
 楼主| 发表于 2007-5-5 09:28:00 | 显示全部楼层
请有知道的高手赐教,谢谢!!!
发表于 2007-5-15 09:34:00 | 显示全部楼层

RetVal = object.AddSpline(PointsArray, StartTangent, EndTangent)

用这个行不行呀

发表于 2007-5-15 19:16:00 | 显示全部楼层
样条曲线!
发表于 2007-5-16 09:13:00 | 显示全部楼层

嗯,样条曲线可以!主要是StartTangent、 EndTangent这两个参数的设置,在这两个参数中的三个元素是不是第一个是对于X轴的tangent,第二个参数是关于Y轴的tangent,第三个参数是关于Z轴的tangent.

我做了一个桥型曲线,效果还可以

Sub drawspline()
Dim x As AcadSpline
Dim pt(1 To 75) As Double
Dim xlapp As Excel.Application
Dim xlbook As Workbook
Dim xlsheet As Worksheet
Dim startangent(0 To 2) As Double
Dim endtangent(0 To 2) As Double
startangent(0) = 0
startangent(1) = 0
startangent(2) = 0
endtangent(0) = 0
endtangent(1) = 0
endtangent(2) = 0
Set xlsApp = New Excel.Application
Set xlbook = xlsApp.Workbooks.Open("F:\CAD练习\book1.xls")
Set xlsheet = xlbook.Worksheets("sheet1")
For i = 1 To 75 Step 3
   With xlsheet
   pt(i) = .Cells(i, 1)
   pt(i + 1) = .Cells(i, 2)
   pt(i + 2) = .Cells(i, 3)
   End With
  
Next i
Set x = ThisDrawing.ModelSpace.AddSpline(pt, startangent, endtangent)

End Sub

 楼主| 发表于 2007-5-16 10:00:00 | 显示全部楼层

谢谢你们!

我试试看。

 楼主| 发表于 2007-5-16 11:14:00 | 显示全部楼层

我刚试过了,是一条光滑的曲线,但在所有点画完后,又与原点连接了,这是怎么回事?请问怎样解决?

谢谢!!!

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-26 15:50 , Processed in 0.175657 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表